



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle在线重定义DBMS_REDEFINITION 普通表—&gt;分区表</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle在线重定义DBMS_REDEFINITION 普通表—&gt;分区表</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-13 09:54:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>实验环境：RHEL 6.4 + Oracle 11.2.0.3<br />实验：在线重定义 普通表 为 分区表，包括主键对应的索引都改造为分区索引.</p>
<p>1,构造普通表t_objects</p>
<div>
<pre class="prettyprint linenums">conn test1/test1;<br />
create table t_objects as select * from dba_objects;<br />
SQL&gt; select count(1) from t_objects;

  COUNT(1)<br />
----------<br />
    468738

--t_objects建立主键和索引<br />
alter table t_objects add constraint pk_objects primary key (created, object_id);<br />
create index i_objects on t_objects(object_id, STATUS);

--表有主键，确认表可以重定义：<br />
SQL&gt; EXEC DBMS_REDEFINITION.CAN_REDEF_TABLE('test1','t_objects');

PL/SQL procedure successfully completed.

--若表无主键 可以采用rowid重定义：<br />
SQL&gt; EXEC DBMS_REDEFINITION.CAN_REDEF_TABLE('test1','t_objects',2);

PL/SQL procedure successfully completed.
</pre>
</div>
<p>2,创建重定义需要的临时表</p>
<div>
<pre class="prettyprint linenums">-- Create table<br />
create table T_OBJECTS_TEMP<br />
(<br />
  OWNER          VARCHAR2(30),<br />
  OBJECT_NAME    VARCHAR2(128),<br />
  SUBOBJECT_NAME VARCHAR2(30),<br />
  OBJECT_ID      NUMBER not null,<br />
  DATA_OBJECT_ID NUMBER,<br />
  OBJECT_TYPE    VARCHAR2(19),<br />
  CREATED        DATE not null,<br />
  LAST_DDL_TIME  DATE,<br />
  TIMESTAMP      VARCHAR2(19),<br />
  STATUS         VARCHAR2(7),<br />
  TEMPORARY      VARCHAR2(1),<br />
  GENERATED      VARCHAR2(1),<br />
  SECONDARY      VARCHAR2(1),<br />
  NAMESPACE      NUMBER,<br />
  EDITION_NAME   VARCHAR2(30)<br />
)partition by range(created)(<br />
  partition P20130601 values less than (TO_DATE(' 2013-06-01 00:00:00', 'SYYYY-MM-DD HH24:MI:SS', 'NLS_CALENDAR=GREGORIAN'))<br />
    tablespace DBS_D_GRNOPHQ,<br />
  partition P20140607 values less than (TO_DATE(' 2014-06-07 00:00:00', 'SYYYY-MM-DD HH24:MI:SS', 'NLS_CALENDAR=GREGORIAN'))<br />
    tablespace DBS_D_GRNOPHQ,<br />
  partition P20140731 values less than (TO_DATE(' 2014-07-31 00:00:00', 'SYYYY-MM-DD HH24:MI:SS', 'NLS_CALENDAR=GREGORIAN'))<br />
    tablespace DBS_D_GRNOPHQ<br />
);
</pre>
</div>
<p>3,开始重定义</p>
<div>
<pre class="prettyprint linenums">exec DBMS_REDEFINITION.START_REDEF_TABLE('test1','t_objects','t_objects_temp');
</pre>
</div>
<p>注；若无主键不能这样重定义，需要指定以rowid重定义，示例如下：</p>
<div>
<pre class="prettyprint linenums">SQL&gt; exec DBMS_REDEFINITION.START_REDEF_TABLE('test1','t_objects','t_objects_temp',null,2);   

PL/SQL procedure successfully completed.
</pre>
</div>
<p>4,开始拷贝表的属性（本次未做，因为这样转换的，索引不是分区索引）</p>
<div>
<pre class="prettyprint linenums">DECLARE<br />
 error_count pls_integer := 0;<br />
BEGIN<br />
    DBMS_REDEFINITION.COPY_TABLE_DEPENDENTS(<br />
        uname =&gt; 'test1',<br />
        orig_table =&gt; 't_objects',<br />
        int_table =&gt; 't_objects_temp',<br />
        ignore_errors =&gt; TRUE,<br />
        num_errors =&gt; error_count);<br />
    DBMS_OUTPUT.PUT_LINE('errors := ' || TO_CHAR(error_count));<br />
END;<br />
/
</pre>
</div>
<p>--经实验，在开始重定义之后在临时表上创建local索引，重定义完成后，主键对应的索引也是分区索引;</p>
<div>
<pre class="prettyprint linenums">alter table t_objects_temp add constraint pk_objects_temp primary key (created, object_id) using index local;<br />
create index i_objects_temp on t_objects_temp(object_id, STATUS) local;
</pre>
</div>
<p>5,同步数据</p>
<div>
<pre class="prettyprint linenums">exec DBMS_REDEFINITION.SYNC_INTERIM_TABLE (uname =&gt; 'test1',orig_table  =&gt; 't_objects',int_table  =&gt; 't_objects_temp');
</pre>
</div>
<p>6,收集中间表的统计信息(选做)</p>
<div>
<pre class="prettyprint linenums">EXEC DBMS_STATS.gather_table_stats('test1', 't_objects_temp', cascade =&gt; TRUE);
</pre>
</div>
<p>7,完成重定义</p>
<div>
<pre class="prettyprint linenums">exec DBMS_REDEFINITION.FINISH_REDEF_TABLE(uname =&gt; 'test1',orig_table =&gt; 't_objects',int_table =&gt; 't_objects_temp');
</pre>
</div>
<div>
<pre class="prettyprint linenums">EXEC DBMS_REDEFINITION.FINISH_REDEF_TABLE('TEST1','T_OBJECTS','T_OBJECTS_TEMP');
</pre>
</div>
<p>8,删除临时表</p>
<div>
<pre class="prettyprint linenums">drop table t_objects_temp purge;
</pre>
</div>
<p>9,修改索引，约束名称和原表一致</p>
<div>
<pre class="prettyprint linenums">alter index I_OBJECTS_TEMP rename to I_OBJECTS;<br />
alter index PK_OBJECTS_TEMP rename to PK_OBJECTS;<br />
alter table t_objects rename constraint pk_objects_temp to pk_objects;
</pre>
</div>
<p>10,ABORT_REDEF_TABLE使用</p>
<p>在FINISH_REDEF_TABLE之前，可以使用abort_redef_table停止重定义</p>
<div>
<pre class="prettyprint linenums">SQL&gt; select * from cat;

TABLE_NAME                     TABLE_TYPE<br />
------------------------------ -----------<br />
MLOG$_T_OBJECTS                TABLE<br />
T_OBJECTS                      TABLE<br />
T_OBJECTS_TEMP                 TABLE

SQL&gt; exec DBMS_REDEFINITION.ABORT_REDEF_TABLE ('test1','t_objects','t_objects_temp');

PL/SQL procedure successfully completed.

SQL&gt; select * from cat;

TABLE_NAME                     TABLE_TYPE<br />
------------------------------ -----------<br />
T_OBJECTS                      TABLE<br />
T_OBJECTS_TEMP                 TABLE
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m960g749.html">修复bootstrap daterangepicker中的3个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdjmwjq.html">Sigmaplot 13 破解版什么地方可以下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd2ez79.html">spring mvc ajax 400解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5m50q.html">android 62  手机存储目录的划分</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1www19.html">程序被送入后台后，向 iOS 借时间，完成长期任务-备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzo0k9.html">vs2010调试快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde6zjx9.html">javaWeb项目带红色感叹号问题原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yogln8.html">【Tomcat】java&period;lang&period;OutOfMemoryError</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl3jk9.html">&lbrack;原&rsqb;MobileSubstrate 工作流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey7yjm9.html">linux服务器ssh、公匙和密钥实战详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zop5k1q.html">keil应用小贴士：Use MicroLIB是干什么的</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j103v8.html">numpy&period;squeeze&lpar;&rpar;是干啥的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0ll1q.html">Pandas常用功能总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjewxl9.html">MySQL 导入导出数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd2n509.html">Android实现图片的压缩、旋转工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll5n40q.html">winform数据存储的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2z00q.html">ODAC（V9&period;5&period;15&rpar; 学习笔记（二）控件列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykk0xq.html">sudo command</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vz7o4q.html">【LOJ】&num;2511&period; 「BJOI2018」双人猜数游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pnkdw8.html">BZOJ4767&colon; 两双手【组合数学&plus;容斥原理】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/390mwz48.html">Mysql 学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/390r7o49.html">转载一些Android性能优化建议</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25wjwq.html">GiuHub 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m2njoq.html">centos中yum安装mysql路径</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwdr78.html">window&period;location&period;href 中文乱码问题。。。。</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m22zpq.html">SQL Server复制出错文章集锦</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyyyxjq.html">SQL Server全时区转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93wprzq.html">旺信UWP正式版发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25xzvq.html">iTextSharp 116秒处理6G的文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdo1e9.html">&period;NET 的 Debug 和 Release build 对执行速度的影响</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
